<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Defining New Variables</TITLE>
<link href="builder_14.html" rel=Next>
<link href="builder_12.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_12.html">previous</A>, <A HREF="builder_14.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC31" HREF="builder_toc.html#TOC31">Defining New Variables</A></H2>
<P>
<A NAME="IDX93"></A>
The builder provides a <CODE>new_sym()</CODE> function to create new SUIF
variables.  In order to create a variable, the type of the variable is
specified by using either the SUIF <CODE>type_node</CODE> structure or
the builder <CODE>const_type</CODE> enum. The <CODE>const_type</CODE> enum can be
used only to define a few basic types (<CODE>cst_int, cst_double,
cst_float, cst_char, cst_str</CODE>).  The name of the new variable can be
optionally specified.  If no name is specified, a unique name is
allocated by the builder. The function <CODE>get_sym()</CODE> can be used to
directly obtain the SUIF structure (<CODE>sym_node</CODE>) of a
builder-created variable.  See section <A HREF="builder_37.html#SEC68">Defining Variables and Generating New Type Definitions</A> for
detailed information on defining new variables.

<PRE>
        block v1(block::new_sym(cst_int, "v1"));
        var_sym * symv1 = (var_sym *)v1.get_sym();
        block v2(block::new_sym(v1-&#62;type(), "v2"));
</PRE>

<P>
<A NAME="IDX94"></A>
<A NAME="IDX95"></A>
<A NAME="IDX96"></A>
<A NAME="IDX97"></A>
<A NAME="IDX98"></A>
<A NAME="IDX99"></A>
<A NAME="IDX100"></A>

</P>
<P>
<STRONG>Note:</STRONG> In the current implementation all the variables that are
created are local variables of the current procedure.  There is no way
to create global variables or variables within inner scopes in this
release.

</P>


<H3><A NAME="SEC32" HREF="builder_toc.html#TOC32">Lables</A></H3>
<P>
A label symbol can be created using the <CODE>new_label()</CODE> command. 

</P>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_12.html">previous</A>, <A HREF="builder_14.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
